<?php
/**
 * 魔术方法一
 * 1.其实我们已经学过的构造方法也是魔术方法__construct()
 * 2.魔术方法是用二个下划线开始的特殊方法,之所以叫魔术方法,是
 * 因为在类中名类外,用户都不可能直接调用,而是由系统自动调用
 * 对于用户来说,这个过程是不透明的,看不到,但可以感知到
 * 3.一般来说,魔术方法,都是在用户的非法操作时自动调用
 * 常用的魔术方法:
 * (1) __get(),__set()
 * (2) __isset(),__unset()
 * (3) __call(),__callStatic()
 * (4) __toString(),__clone()
 */
class Demo1
{
    private $name;
    private $age;
    //构造魔术方法
    public function __construct($name, $age)
    {
        $this->name = $name;
        $this->age = $age;
    }
    //因为$name,$sex是私有属性,外部不可访问,按我们之前的做法,创建一个外部访问接口
    public function getName()
    {
        return $this->name;
    }
    public function getAge()
    {
        return $this->age;
    }
    //由于这种外部访问私有属性的情况经常发生,为了防止访问错误,可以创建一个__get()对访问进行自动处理
    //过滤掉非法请求,正常访问应该是允许的
    public function __get($proName) { //参数就是属性名称
//        return $this->$proName;
        //现在开始进行访问权限控制,例如仅允许姓名等于Peter Zhu的访问
        if ($this->name == 'Peter Zhu') {
            return $this->$proName;
        } else {
            echo '<h3 style="color:red">'.$this->name.'.无权访问:'.$proName.'</h3>';
        }
    }

    //创建魔术方法,__set(),如果在类外部进行属性的赋值操作,会自动调用它
    //__set()有二个参数:属性名与属性值
    public function __set($proName,$proValue)
    {
        if ($proName == 'age'){ //判断年龄是否是一个合法值
            if ($proValue > 1 && $proValue < 120) {
                return $this->$proName = $proValue;
            } else {
                echo '<h3 style="color:red">'.$proValue.'数据非法'.'</h3>';
            }
        }
        //对类内的私有属性进行赋值
        return $this->$proName = $proValue;
    }

}
$obj = new Demo1('Peter Zhu',30);
//echo $obj->name;//访问不到,怎么才能访问到呢?
echo $obj->getName();//这样才行,但我就是想用属性访问,不想用方法,如何办到
echo '<hr>';
//如果想访问$age,怎么办?
echo $obj->getAge();
//现在就可以直接用属性为访问了
echo '<hr>';
echo $obj->name;
echo '<hr>';
echo $obj->age;
//外部直接设置类的私有属性
//$obj->age=40; //肯定出错
$obj->age = 130;
$obj->name = '朱老师';
echo $obj->name; //只能是Peter Zhu,除非重新初始化name属性


